<?php
// config check
ob_start();
require "config/config.php";
$config_content = ob_get_contents();
ob_end_clean();
// attributes check
ob_start();
chdir('config');
require "attributes.php";
chdir('../');
$attributes_content = ob_get_contents();
ob_end_clean();

$error_occured = false;
?>
<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Galaxytool installation program for version <?php echo VERSION; ?></title>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<link rel="stylesheet" type="text/css" href="secret/styles.css" />
</head>
<body>
<?php
if (!isset($_GET['action']) || $_GET['action'] != "install") {
?>
<form action="index.php" method="GET">
<table class="standard" cellpadding="0" cellspacing="0" border="0" style="margin-top:200px; width:250px;" align="center">
<tr class="firstcolor"><td colspan="2" align="center" class="tblhead">Galaxytool <?php echo VERSION; ?> - Installation check</td></tr>
<?php
if ($config_content != "") {
	echo "content: |".utf8_encode($config_content)."|";
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: config.php</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: config.php</td><td class=\"success\">success</td></tr>\n";
}
if (!empty($attributes_content)) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: attributes.php</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: attributes.php</td><td class=\"success\">success</td></tr>\n";
}
if (empty($owner)) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Owner</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Owner</td><td class=\"success\">$owner</td></tr>\n";
}
if (empty($default_language)) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Language</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Language</td><td class=\"success\">$default_language</td></tr>\n";
}
if (empty($global_universe) || (!is_numeric($global_universe) && preg_replace("/[a-zA-Z0-9_\-]/","",$global_universe) != "" )) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Universe</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Universe</td><td class=\"success\">$global_universe</td></tr>\n";
}
if (!is_numeric($speed_rate) || $speed_rate <= 0) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Speedrate</td><td class=\"failure\">failed</td></tr>\n";
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Speedrate</td><td class=\"success\">$speed_rate</td></tr>\n";
}
$link = mysql_connect($dbhost, $dbusername, $dbpassword);
if (!$link) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL connection</td><td class=\"failure\">failed</td></tr>\n";
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Database existency</td><td class=\"failure\">failed</td></tr>\n";
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL connection</td><td class=\"success\">success</td></tr>\n";
	$db_selected = mysql_select_db($dbname, $link);
	if (!$db_selected) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Database existency</td><td class=\"failure\">failed</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Database existency</td><td class=\"success\">success</td></tr>\n";

		$query = "SELECT VERSION() as version";
		$res = mysql_query($query) or die(mysql_error());
		$version = mysql_fetch_object($res);
		if (strpos($version->version,"-") > 0) {
			$version = substr($version->version,0,strpos($version->version,"-"));
		} else {
			$version = $version->version;
		}

		$subversion = explode(".",$version);
		if (!isset($subversion[0]) || $subversion[0] < 5) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
			$error_occured = true;
		} else {
			/*if ($subversion[0] == 4) {
			// MySQL 4.x.x
			if (!isset($subversion[1]) || $subversion[1] < 1) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
			$error_occured = true;
			} else {
			if (!isset($subversion[2]) || $subversion[2] < 16) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
			$error_occured = true;
			} else {
			// success
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"success\">$version</td></tr>\n";
			}
			}
			} else*/if ($subversion[0] == 5) {
			// MySQL 5.x.x
			// http://bugs.galaxytool.eu/view.php?id=375 <-- v5.0.87 has a bug
			if (!isset($subversion[1]) || !isset($subversion[2]) || ($subversion[1] == 0 && $subversion[2] < 16) || ($subversion[1] == 0 && $subversion[2] == 87)) {
				echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
				$error_occured = true;
			} else {
				// success
				echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"success\">$version</td></tr>\n";
			}
			} elseif ($subversion[0] == 6) {
				// MySQL 6.x.x
				echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"success\">$version</td></tr>\n";
			}
		}
	}
}
if (substr(phpversion(),0,1) > 4) {
	if (strpos(phpversion(), '-') !== false) {
		$version = substr(phpversion(),0,strpos(phpversion(), '-'));
	} else {
		$version = phpversion();
	}
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">PHP version check</td><td class=\"success\">$version</td></tr>\n";
} else {
	$error_occured = true;
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">PHP version check</td><td class=\"failure\">failed</td></tr>\n";
}

$db_tablenames = array();
array_push($db_tablenames,$dbtablename);
array_push($db_tablenames,$utablename);
array_push($db_tablenames,$playertable);
array_push($db_tablenames,$allytable);
array_push($db_tablenames,$noticetable);
array_push($db_tablenames,$reporttable);
array_push($db_tablenames,$iptablename);
array_push($db_tablenames,$shouttable);
array_push($db_tablenames,$allyhistory);
array_push($db_tablenames,$playerhistory);
array_push($db_tablenames,$fleetmovetable);
array_push($db_tablenames,$player_activity);
array_push($db_tablenames,$messagetable);
array_push($db_tablenames,$combattable);
array_push($db_tablenames,$combatparty);
array_push($db_tablenames,$reportarchive);

$tablename_error = false;
foreach($db_tablenames as $tablename) {
	// check tablenames
	$tempname = preg_replace("/[^0-9a-z\_]/i","",$tablename);
	if (empty($tablename) || strlen($tablename) > 64 || $tempname != $tablename) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Tablename: '$tablename'</td><td class=\"failure\">failed</td></tr>\n";
		$tablename_error = true;
	}
}
if ($tablename_error === false) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Tablenames</td><td class=\"success\">success</td></tr>\n";
}

?>
<tr class="firstcolor"><td colspan="2">&nbsp;</td></tr>
<?php
if (!$error_occured) {
	echo "<tr class=\"firstcolor\"><td colspan=\"2\" align=\"center\"><a class=\"link\" href=\"install.php?action=install\">Install</a></td></tr>\n";
} else {
	echo "<tr class=\"firstcolor\"><td colspan=\"2\" align=\"center\"><a class=\"link\" href=\"install.php\">Check again</a></td></tr>\n";
}

} else {
	echo '<table class="standard" cellpadding="0" cellspacing="0" border="0" style="margin-top:200px; width:250px;" align="center">';

	mysql_connect($dbhost,$dbusername,$dbpassword) or die(mysql_error());
	mysql_select_db($dbname) or die(mysql_error());

	// send feedback - do not stop if this fails
	/*
	about the feedback:
	I collect information about the used MySQL version and PHP Version.
	I am using this information to know which versions I can skip.
	E.g. if only php5 would be used, I could use the php5 class system.
	If MySQL 5 or above would be used, I could use new MySQL 5 features.
	*/
	$query = "SELECT VERSION() as version";
	$res = mysql_query($query) or die(mysql_error());
	$version = mysql_fetch_object($res);
	$version = $version->version;
	$fp = @fopen("http://www.galaxytool.eu/feedback.php?php_version=".substr(phpversion(),0,strpos(phpversion(), '-'))."&mysql_version=".substr($version,0,strpos($version, '-')),"r");
	@fclose($fp);

	// start installation

	// Tabelle fuer die Galaxieansichten
	$query = "CREATE TABLE $dbtablename (
			  galaxy int(2) NOT NULL default '0',
			  system int(3) NOT NULL default '0',
			  planet int(2) NOT NULL default '0',
			  player_id int(10) unsigned NOT NULL default '0',
			  moon enum('true','false') NOT NULL default 'false',
			  moonsize smallint(5) unsigned NOT NULL default '0',
			  metal int(10) unsigned NOT NULL default '0',
			  crystal int(10) unsigned NOT NULL default '0',
			  planetname varchar(40) NOT NULL default '',
			  last_update datetime NOT NULL default '0000-00-00 00:00:00',
			  user_id smallint(5) unsigned NOT NULL default '0',
			  PRIMARY KEY  (galaxy,system,planet),
			  KEY player_id (player_id),
			  KEY moon (moon),
			  KEY last_update (last_update),
			  KEY metal (metal),
			  KEY crystal (crystal),
			  KEY (user_id)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: galaxy</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: galaxy</td><td class=\"success\">success</td></tr>\n";
	}

	// Tabelle fuer die Benutzerverwaltung
	$query = "CREATE TABLE $utablename (
			  id smallint(10) unsigned NOT NULL auto_increment,
			  username varchar(40) NOT NULL default '',
			  userpass varchar(32) NOT NULL default '',
			  plugin_token varchar(32) DEFAULT NULL,
			  ogame_playerid int(11) unsigned NOT NULL default '0',
			  new_password enum('true','false') NOT NULL default 'true',
			  email varchar(50) NOT NULL default '',
			  language varchar(20) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
			  ingame varchar(40) NOT NULL default '',
			  allytag varchar(40) NOT NULL default '',
			  timezone_offset varchar(6) NOT NULL default '+00:00',
			  ogame_offset varchar(6) NOT NULL DEFAULT '+00:00',
			  getting_started enum('expand','collapse','hidden') NOT NULL DEFAULT 'expand',
  			  plugin_info enum('expand','collapse','hidden') NOT NULL DEFAULT 'expand',
			  stylepath varchar(255) NOT NULL default '',
			  is_admin enum('true','false') NOT NULL default 'false',
			  cansearch enum('true','false') NOT NULL default 'false',
			  caninsert enum('true','false') NOT NULL default 'false',
			  candelete enum('true','false') NOT NULL default 'false',
			  statusview enum('true','false') NOT NULL default 'false',
			  probeview enum('true','false') NOT NULL default 'false',
			  userman enum('true','false') NOT NULL default 'false',
			  allyhistory enum('true','false') NOT NULL default 'false',
			  diplomatic enum('true','false') NOT NULL default 'false',
			  fleetinfo enum('true','false') NOT NULL default 'false',
			  activities enum('true','false') NOT NULL default 'false',
			  maintenance enum('true','false') NOT NULL default 'false',
			  status enum('email','admin','active') NOT NULL default 'email',
			  logins smallint(5) unsigned NOT NULL default '0',
			  lastlogin datetime NOT NULL default '0000-00-00 00:00:00',
			  last_action datetime NOT NULL default '0000-00-00 00:00:00',
			  last_submit date NOT NULL default '0000-00-00',
			  search_results mediumint(8) unsigned NOT NULL default '25',
			  links text NOT NULL,
			  bb_coordinates varchar(25) NOT NULL default 'deeppink',
			  bb_moon varchar(25) NOT NULL default 'burlywood',
			  bb_debris varchar(25) NOT NULL default 'firebrick',
			  bb_ally varchar(25) NOT NULL default 'tomato',
			  bb_allydetails varchar(25) NOT NULL default 'coral',
			  bb_playername varchar(25) NOT NULL default 'teal',
			  bb_banned varchar(25) NOT NULL default 'red',
			  bb_vacation varchar(25) NOT NULL default 'skyblue',
			  bb_noob varchar(25) NOT NULL default 'limegreen',
			  bb_inactive varchar(25) NOT NULL default 'silver',
			  bb_longinactive varchar(25) NOT NULL default 'silver',
			  session_save text NOT NULL,
			  PRIMARY KEY  (id),
			  UNIQUE KEY username (username),
			  KEY last_action (last_action),
			  KEY ingame (ingame),
			  KEY ogame_playerid (ogame_playerid),
			  KEY is_admin (is_admin)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: usertable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: usertable</td><td class=\"success\">success</td></tr>\n";
	}

	// Adminuser eintragen
	$query = "INSERT INTO $utablename
		  (id, username, userpass, stylepath, is_admin, cansearch, caninsert, candelete, statusview, probeview, userman, allyhistory, diplomatic, fleetinfo, activities, maintenance, status, links, session_save) VALUES
		  (1, 'admin', md5('galatool'),'styles.css', 'true', 'true', 'true', 'true', 'true', 'true', 'true', 'true', 'true', 'true', 'true', 'true', 'active', 'Galaxytool;http://www.galaxytool.eu', '')";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Creating Adminuser</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Creating Adminuser</td><td class=\"success\">success</td></tr>\n";
	}

	// Spielertabelle
	$query = "CREATE TABLE $playertable (
			  id int(10) unsigned NOT NULL auto_increment,
			  playername varchar(40) NOT NULL default '',
			  ogame_playerid int(11) unsigned default NULL,
			  alliance_id int(10) unsigned NOT NULL default '0',
			  rank smallint(5) unsigned NOT NULL default '0',
			  points int(10) unsigned NOT NULL default '0',
			  frank smallint(5) unsigned NOT NULL default '0',
			  fpoints int(10) unsigned NOT NULL default '0',
			  rrank smallint(5) unsigned NOT NULL default '0',
			  rpoints int(10) unsigned NOT NULL default '0',
			  erank smallint(5) unsigned NOT NULL DEFAULT '0',
			  epoints int(10) unsigned NOT NULL DEFAULT '0',
			  hrank smallint(5) unsigned NOT NULL DEFAULT '0',
			  hpoints int(11) NOT NULL DEFAULT '0',
			  fbrank smallint(5) unsigned NOT NULL DEFAULT '0',
			  fbpoints int(10) unsigned NOT NULL DEFAULT '0',
			  fdrank smallint(5) unsigned NOT NULL DEFAULT '0',
			  fdpoints int(10) unsigned NOT NULL DEFAULT '0',
			  flrank smallint(5) unsigned NOT NULL DEFAULT '0',
			  flpoints int(10) unsigned NOT NULL DEFAULT '0',
			  last_stats_update datetime NOT NULL default '0000-00-00 00:00:00',
			  user_id smallint(5) unsigned NOT NULL default '0',
			  homegalaxy int(2) UNSIGNED NOT NULL default '0',
			  homesystem int(3) UNSIGNED NOT NULL default '0',
			  homeplanet int(2) UNSIGNED NOT NULL default '0',
			  noob enum('true','false') NOT NULL default 'false',
			  banned enum('true','false') NOT NULL default 'false',
			  vacation enum('true','false') NOT NULL default 'false',
			  inactive enum('true','false') NOT NULL default 'false',
			  long_inactive enum('true','false') NOT NULL default 'false',
			  diplomatic_status enum('nap','ally','war','boycott','neutral','nothing','own','wing') NOT NULL default 'nothing',
			  spiolvl tinyint(3) unsigned NOT NULL default '0',
			  computech tinyint(3) unsigned NOT NULL default '0',
			  waffentech tinyint(3) unsigned NOT NULL default '0',
			  schildtech tinyint(3) unsigned NOT NULL default '0',
			  rpz tinyint(3) unsigned NOT NULL default '0',
			  energytech tinyint(3) unsigned NOT NULL default '0',
			  hypertech tinyint(3) unsigned NOT NULL default '0',
			  vbt tinyint(3) unsigned NOT NULL default '0',
			  impulse tinyint(3) unsigned NOT NULL default '0',
			  hra tinyint(3) unsigned NOT NULL default '0',
			  lasertech tinyint(3) unsigned NOT NULL default '0',
			  iontech tinyint(3) unsigned NOT NULL default '0',
			  plasmatech tinyint(3) unsigned NOT NULL default '0',
			  forschungsnetz tinyint(3) unsigned NOT NULL default '0',
			  expedition tinyint(3) unsigned NOT NULL default '0',
			  gravi tinyint(3) unsigned NOT NULL default '0',
			  last_tech_update datetime NOT NULL default '0000-00-00 00:00:00',
			  PRIMARY KEY  (id),
			  UNIQUE KEY ogame_playerid (ogame_playerid),
			  KEY alliance_id (alliance_id),
			  KEY noob (noob),
			  KEY banned (banned),
			  KEY vacation (vacation),
			  KEY inactive (inactive),
			  KEY playername (playername),
			  KEY rank (rank),
			  KEY frank (frank),
			  KEY last_stats_update (last_stats_update),
			  KEY diplomatic_status (diplomatic_status)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: playertable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: playertable</td><td class=\"success\">success</td></tr>\n";
	}

	// Allytabelle
	$query = "CREATE TABLE $allytable (
			  id int(10) unsigned NOT NULL auto_increment,
			  ogame_allyid int(11) unsigned default NULL,
			  allyname varchar(40) default NULL,
			  rank smallint(5) unsigned NOT NULL default '0',
			  points int(10) unsigned NOT NULL default '0',
			  frank smallint(5) unsigned NOT NULL default '0',
			  fpoints int(10) unsigned NOT NULL default '0',
			  rrank smallint(5) unsigned NOT NULL default '0',
			  rpoints int(10) unsigned NOT NULL default '0',
			  erank smallint(5) unsigned NOT NULL DEFAULT '0',
			  epoints int(10) unsigned NOT NULL DEFAULT '0',
			  hrank smallint(5) unsigned NOT NULL DEFAULT '0',
			  hpoints int(11) NOT NULL DEFAULT '0',
			  fbrank smallint(5) unsigned NOT NULL DEFAULT '0',
			  fbpoints int(10) unsigned NOT NULL DEFAULT '0',
			  fdrank smallint(5) unsigned NOT NULL DEFAULT '0',
			  fdpoints int(10) unsigned NOT NULL DEFAULT '0',
			  flrank smallint(5) unsigned NOT NULL DEFAULT '0',
			  flpoints int(10) unsigned NOT NULL DEFAULT '0',
			  members smallint(5) unsigned NOT NULL default '0',
			  diplomatic_status enum('nap','ally','war','boycott','neutral','nothing','own','wing') default 'nothing',
			  last_update datetime default '0000-00-00 00:00:00',
			  user_id smallint(5) unsigned NOT NULL default '0',
			  PRIMARY KEY  (id),
			  UNIQUE KEY ogame_allyid (ogame_allyid),
			  KEY allyname (allyname),
			  KEY last_update (last_update),
			  KEY diplomatic_status (diplomatic_status),
			  KEY rank (rank)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: allytable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: allytable</td><td class=\"success\">success</td></tr>\n";
	}

	// Notiztabelle
	$query = "CREATE TABLE $noticetable (
              id int(11) NOT NULL auto_increment,
              noticetext text NOT NULL,
              player_id int(10) unsigned NOT NULL default '0',
              last_update datetime NOT NULL default '0000-00-00 00:00:00',
              PRIMARY KEY  (id),
              UNIQUE KEY player_id (player_id)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: noticetable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: noticetable</td><td class=\"success\">success</td></tr>\n";
	}

	// Reporttabelle
	$query = "CREATE TABLE $reporttable (
			  id int(10) unsigned NOT NULL auto_increment,
			  galaxy int(2) unsigned NOT NULL default '0',
			  system int(3) unsigned NOT NULL default '0',
			  planet int(2) unsigned NOT NULL default '0',
			  planetname varchar(40) NOT NULL default '',
			  moon enum('true','false') NOT NULL default 'false',
			  msg_id int(10) unsigned default NULL,
			  metal int(10) unsigned NOT NULL default '0',
			  crystal int(10) unsigned NOT NULL default '0',
			  deuterium int(10) unsigned NOT NULL default '0',
			  energy int(10) unsigned NOT NULL default '0',
			  kt mediumint(8) unsigned NOT NULL default '0',
			  gt mediumint(8) unsigned NOT NULL default '0',
			  lj mediumint(8) unsigned NOT NULL default '0',
			  sj mediumint(8) unsigned NOT NULL default '0',
			  krz mediumint(8) unsigned NOT NULL default '0',
			  ss mediumint(8) unsigned NOT NULL default '0',
			  kolo mediumint(8) unsigned NOT NULL default '0',
			  rec mediumint(8) unsigned NOT NULL default '0',
			  spio mediumint(8) unsigned NOT NULL default '0',
			  bomb mediumint(8) unsigned NOT NULL default '0',
			  zerri mediumint(8) unsigned NOT NULL default '0',
			  ds mediumint(8) unsigned NOT NULL default '0',
			  skrz mediumint(8) unsigned NOT NULL default '0',
			  sat mediumint(8) unsigned NOT NULL default '0',
			  rak mediumint(8) unsigned NOT NULL default '0',
			  ll mediumint(8) unsigned NOT NULL default '0',
			  sl mediumint(8) unsigned NOT NULL default '0',
			  ion mediumint(8) unsigned NOT NULL default '0',
			  gauss mediumint(8) unsigned NOT NULL default '0',
			  plasma mediumint(8) unsigned NOT NULL default '0',
			  ksk mediumint(8) unsigned NOT NULL default '0',
			  gsk mediumint(8) unsigned NOT NULL default '0',
			  arak mediumint(8) unsigned NOT NULL default '0',
			  irak mediumint(8) unsigned NOT NULL default '0',
			  memi tinyint(3) unsigned NOT NULL default '0',
			  krimi tinyint(3) unsigned NOT NULL default '0',
			  deutsyn tinyint(3) unsigned NOT NULL default '0',
			  solar tinyint(3) unsigned NOT NULL default '0',
			  fusion tinyint(3) unsigned NOT NULL default '0',
			  robo tinyint(3) unsigned NOT NULL default '0',
			  nani tinyint(3) unsigned NOT NULL default '0',
			  rawe tinyint(3) unsigned NOT NULL default '0',
			  mesp tinyint(3) unsigned NOT NULL default '0',
			  krissp tinyint(3) unsigned NOT NULL default '0',
			  deutsp tinyint(3) unsigned NOT NULL default '0',
			  folab tinyint(3) unsigned NOT NULL default '0',
			  terra tinyint(3) unsigned NOT NULL default '0',
			  allydep tinyint(3) unsigned NOT NULL default '0',
			  raksilo tinyint(3) unsigned NOT NULL default '0',
			  mbase tinyint(3) unsigned NOT NULL default '0',
			  sensor tinyint(3) unsigned NOT NULL default '0',
			  sprungtor tinyint(3) unsigned NOT NULL default '0',
			  spiolvl tinyint(3) unsigned NOT NULL default '0',
			  computech tinyint(3) unsigned NOT NULL default '0',
			  waffentech tinyint(3) unsigned NOT NULL default '0',
			  schildtech tinyint(3) unsigned NOT NULL default '0',
			  rpz tinyint(3) unsigned NOT NULL default '0',
			  energytech tinyint(3) unsigned NOT NULL default '0',
			  hypertech tinyint(3) unsigned NOT NULL default '0',
			  vbt tinyint(3) unsigned NOT NULL default '0',
			  impulse tinyint(3) unsigned NOT NULL default '0',
			  hra tinyint(3) unsigned NOT NULL default '0',
			  lasertech tinyint(3) unsigned NOT NULL default '0',
			  iontech tinyint(3) unsigned NOT NULL default '0',
			  plasmatech tinyint(3) unsigned NOT NULL default '0',
			  forschungsnetz tinyint(3) unsigned NOT NULL default '0',
			  expedition tinyint(3) unsigned NOT NULL default '0' COMMENT 'Expedition technology',
			  gravi tinyint(3) unsigned NOT NULL default '0',
			  fleet_resis bigint(20) unsigned NOT NULL default '0',
			  defence_resis bigint(20) unsigned NOT NULL default '0',
			  scantime datetime NOT NULL default '0000-00-00 00:00:00',
			  user_id smallint(5) unsigned NOT NULL default '0',
			  scanned enum('ressources','fleet','defence','buildings','research') NOT NULL default 'ressources',
			  min_phalanx int(3) unsigned default NULL,
			  max_phalanx int(3) unsigned default NULL,
			  min_rak int(3) unsigned default NULL,
			  max_rak int(3) unsigned default NULL,
			  PRIMARY KEY  (id),
			  UNIQUE KEY coordinates (galaxy,system,planet,moon),
			  KEY scantime (scantime),
			  KEY msg_id (msg_id),
			  KEY metal (metal),
			  KEY crystal (crystal),
			  KEY deuterium (deuterium),
			  KEY min_rak (galaxy,min_rak),
			  KEY min_phalanx (galaxy,min_phalanx),
			  KEY user_id (user_id)
           ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: reporttable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: reporttable</td><td class=\"success\">success</td></tr>\n";
	}

	// IP Tabelle
	$query = "CREATE TABLE $iptablename (
              id int(10) unsigned NOT NULL auto_increment,
              userid smallint(5) unsigned NOT NULL default '0',
              ip varchar(15) NOT NULL default '',
              logintime datetime NOT NULL default '0000-00-00 00:00:00',
              PRIMARY KEY  (id),
              KEY userid (userid)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: IPtable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: IPtable</td><td class=\"success\">success</td></tr>\n";
	}

	// Shouttabelle
	$query = "CREATE TABLE $shouttable (
              id mediumint(8) unsigned NOT NULL auto_increment,
              username varchar(40) NOT NULL default '',
              shouttext varchar(255) NOT NULL default '',
              shoutdate datetime NOT NULL default '0000-00-00 00:00:00',
              PRIMARY KEY  (id)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: shoutbox</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: shoutbox</td><td class=\"success\">success</td></tr>\n";
	}

	// Allianzgeschichte
	$query = "CREATE TABLE $allyhistory (
              alliance_id int(10) unsigned NOT NULL default '0',
              year smallint(5) unsigned NOT NULL default '0',
              month tinyint(3) unsigned NOT NULL default '0',
              day tinyint(3) unsigned NOT NULL default '0',
              rank smallint(5) unsigned NOT NULL default '0',
              points int(10) unsigned NOT NULL default '0',
              frank smallint(5) unsigned NOT NULL default '0',
              fpoints int(10) unsigned NOT NULL default '0',
              rrank smallint(5) unsigned NOT NULL default '0',
              rpoints int(10) unsigned NOT NULL default '0',
			  erank smallint(5) unsigned NOT NULL DEFAULT '0',
			  epoints int(10) unsigned NOT NULL DEFAULT '0',
              members smallint(5) unsigned NOT NULL default '0',
              PRIMARY KEY  (alliance_id,year,month,day)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: allyhistory</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: allyhistory</td><td class=\"success\">success</td></tr>\n";
	}

	// Spielergeschichte
	$query = "CREATE TABLE $playerhistory (
              player_id int(10) unsigned NOT NULL default '0',
              alliance_id int(10) unsigned NOT NULL default '0',
              year smallint(5) unsigned NOT NULL default '0',
              month tinyint(3) unsigned NOT NULL default '0',
              day tinyint(3) unsigned NOT NULL default '0',
              rank smallint(5) unsigned NOT NULL default '0',
              points int(10) unsigned NOT NULL default '0',
              frank smallint(5) unsigned NOT NULL default '0',
              fpoints int(10) unsigned NOT NULL default '0',
              rrank smallint(5) unsigned NOT NULL default '0',
              rpoints int(10) unsigned NOT NULL default '0',
			  erank smallint(5) unsigned NOT NULL DEFAULT '0',
			  epoints int(10) unsigned NOT NULL DEFAULT '0',
              PRIMARY KEY  (player_id,year,month,day)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: playerhistory</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: playerhistory</td><td class=\"success\">success</td></tr>\n";
	}

		// fleet movements table
		$query = "CREATE TABLE $fleetmovetable (
					fleet_id int(10) unsigned NOT NULL,
					sub_fleet_id int(10) unsigned default NULL,
  					mission enum('expedition','colonization','recycle','transport','deployment','espionage','acs_defend','attack','acs_attack','moon_destruction','missile_attack') NOT NULL,
					arrival_time datetime NOT NULL default '0000-00-00 00:00:00',
					returning enum('true','false'),
					origin_galaxy int(2) NOT NULL default '0',
					origin_system int(3) NOT NULL default '0',
					origin_planet int(2) NOT NULL default '0',
					origin_planetname varchar(40) NOT NULL default '',
					origin_moon enum('true','false','unknown'),
					destination_galaxy int(2) NOT NULL default '0',
					destination_system int(3) NOT NULL default '0',
					destination_planet int(2) NOT NULL default '0',
				    destination_planetname varchar(40) NOT NULL default '',
				    destination_moon enum('true','false','unknown'),
  					scantime datetime NOT NULL default '0000-00-00 00:00:00',
				  	metal int(10) unsigned NOT NULL default '0',
				  	crystal int(10) unsigned NOT NULL default '0',
				  	deuterium int(10) unsigned NOT NULL default '0',
  					user_id smallint(5) unsigned NOT NULL default '0',
					kt mediumint(8) unsigned NOT NULL default '0',
					gt mediumint(8) unsigned NOT NULL default '0',
					lj mediumint(8) unsigned NOT NULL default '0',
					sj mediumint(8) unsigned NOT NULL default '0',
					krz mediumint(8) unsigned NOT NULL default '0',
					ss mediumint(8) unsigned NOT NULL default '0',
					kolo mediumint(8) unsigned NOT NULL default '0',
					rec mediumint(8) unsigned NOT NULL default '0',
					spio mediumint(8) unsigned NOT NULL default '0',
					bomb mediumint(8) unsigned NOT NULL default '0',
					zerri mediumint(8) unsigned NOT NULL default '0',
					ds mediumint(8) unsigned NOT NULL default '0',
					skrz mediumint(8) unsigned NOT NULL default '0',
					irak mediumint(8) unsigned NOT NULL default '0',
					PRIMARY KEY (fleet_id, sub_fleet_id),
					KEY origin (origin_galaxy,origin_system,origin_planet),
					KEY (arrival_time),
					KEY (user_id)
			      ) DEFAULT CHARSET=utf8";
		if (!mysql_query($query)) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: fleet movements</td><td class=\"failure\">failure</td></tr>\n";
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
			$error_occured = true;
		} else {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: fleet movements</td><td class=\"success\">success</td></tr>\n";
		}

		// player activity table
		$query = "CREATE TABLE $player_activity (
					id int(10) unsigned NOT NULL auto_increment,
		            player_id int(10) unsigned NOT NULL default '0',
					activity_date date NOT NULL default '0000-00-00',
		            hour tinyint(3) unsigned NOT NULL default '0',
		            minute tinyint(3) unsigned NOT NULL default '0',
		            weekday tinyint(3) unsigned NOT NULL default '0',
		            activity_type enum('galaxyview', 'scan', 'message', 'manual', 'combat_report', 'alliance_page') NOT NULL,

					PRIMARY KEY (id),
					UNIQUE KEY consistency (player_id, activity_date, hour, minute, activity_type)
			      ) DEFAULT CHARSET=utf8";
		if (!mysql_query($query)) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: player activities</td><td class=\"failure\">failure</td></tr>\n";
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
			$error_occured = true;
		} else {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: player activities</td><td class=\"success\">success</td></tr>\n";
		}

		// ingame message table
		$query = "CREATE TABLE $messagetable (
					id int(10) unsigned NOT NULL auto_increment,
		            msg_id int(10) unsigned NOT NULL,
		            messagetime datetime NOT NULL default '0000-00-00 00:00:00',
		            subject varchar(255) NOT NULL default '',
		            player_id_from int(10) unsigned NOT NULL default '0',
		            player_id_to int(10) unsigned NOT NULL default '0',
					message_content TEXT NOT NULL,
		            userid smallint(5) unsigned NOT NULL default '0',
					PRIMARY KEY (id),
					KEY msg_id (msg_id),
					KEY userid (userid)
			      ) DEFAULT CHARSET=utf8";
		if (!mysql_query($query)) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: messages</td><td class=\"failure\">failure</td></tr>\n";
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
			$error_occured = true;
		} else {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: messages</td><td class=\"success\">success</td></tr>\n";
		}

		// combat table
		$query = "CREATE TABLE $combattable (
					id int(10) unsigned NOT NULL auto_increment,
		            msg_id int(10) unsigned NOT NULL,
		            combattime datetime NOT NULL default '0000-00-00 00:00:00',
		            winner enum('attacker','defender','nobody') NOT NULL,
		            loot_metal int(10) unsigned,
			  		loot_crystal int(10) unsigned,
			  		loot_deuterium int(10) unsigned,
		            debris_metal int(10) unsigned,
			  		debris_crystal int(10) unsigned,
			  		public enum('true','false') default 'false',
			  		userid smallint(5) unsigned NOT NULL default '0',
					PRIMARY KEY (id),
					KEY msg_id (msg_id),
					KEY userid (userid)
			      ) DEFAULT CHARSET=utf8";
		if (!mysql_query($query)) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: combats</td><td class=\"failure\">failure</td></tr>\n";
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
			$error_occured = true;
		} else {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: combats</td><td class=\"success\">success</td></tr>\n";
		}

		// combat party table
		$query = "CREATE TABLE $combatparty (
					id int(10) unsigned NOT NULL auto_increment,
					combat_id int(10) unsigned NOT NULL,
					combat_type enum('attacker','defender') NOT NULL,
					player_id int(10) unsigned,
			  		galaxy int(2) unsigned NOT NULL,
			  		system int(3) unsigned NOT NULL,
			  		planet int(2) unsigned NOT NULL,
			  		waffentech tinyint(3) unsigned,
			  		schildtech tinyint(3) unsigned,
			  		rpz tinyint(3) unsigned,
			  		lost_units bigint(20) unsigned DEFAULT NULL,
			  		attack_location enum('true','false') NOT NULL DEFAULT 'false',
					PRIMARY KEY (id),
					KEY combat_id (combat_id),
					KEY player_id (player_id)
			      ) DEFAULT CHARSET=utf8";
		if (!mysql_query($query)) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: combat parties</td><td class=\"failure\">failure</td></tr>\n";
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
			$error_occured = true;
		} else {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: combat parties</td><td class=\"success\">success</td></tr>\n";
		}

		//reportarchive table
$query = "CREATE TABLE $reportarchive (
			  id int(10) unsigned NOT NULL AUTO_INCREMENT,
			  galaxy int(2) unsigned NOT NULL,
			  system int(3) unsigned NOT NULL,
			  planet int(2) unsigned NOT NULL,
			  moon enum('true','false') DEFAULT 'false',
			  msg_id int(10) unsigned DEFAULT NULL,
			  metal int(10) unsigned NOT NULL DEFAULT '0',
			  crystal int(10) unsigned NOT NULL DEFAULT '0',
			  deuterium int(10) unsigned NOT NULL DEFAULT '0',
			  energy int(10) unsigned NOT NULL DEFAULT '0',
			  kt mediumint(8) unsigned NOT NULL DEFAULT '0',
			  gt mediumint(8) unsigned NOT NULL DEFAULT '0',
			  lj mediumint(8) unsigned NOT NULL DEFAULT '0',
			  sj mediumint(8) unsigned NOT NULL DEFAULT '0',
			  krz mediumint(8) unsigned NOT NULL DEFAULT '0',
			  ss mediumint(8) unsigned NOT NULL DEFAULT '0',
			  kolo mediumint(8) unsigned NOT NULL DEFAULT '0',
			  rec mediumint(8) unsigned NOT NULL DEFAULT '0',
			  spio mediumint(8) unsigned NOT NULL DEFAULT '0',
			  bomb mediumint(8) unsigned NOT NULL DEFAULT '0',
			  zerri mediumint(8) unsigned NOT NULL DEFAULT '0',
			  ds mediumint(8) unsigned NOT NULL DEFAULT '0',
			  skrz mediumint(8) unsigned NOT NULL DEFAULT '0',
			  sat mediumint(8) unsigned NOT NULL DEFAULT '0',
			  rak mediumint(8) unsigned NOT NULL DEFAULT '0',
			  ll mediumint(8) unsigned NOT NULL DEFAULT '0',
			  sl mediumint(8) unsigned NOT NULL DEFAULT '0',
			  ion mediumint(8) unsigned NOT NULL DEFAULT '0',
			  gauss mediumint(8) unsigned NOT NULL DEFAULT '0',
			  plasma mediumint(8) unsigned NOT NULL DEFAULT '0',
			  ksk mediumint(8) unsigned NOT NULL DEFAULT '0',
			  gsk mediumint(8) unsigned NOT NULL DEFAULT '0',
			  arak mediumint(8) unsigned NOT NULL DEFAULT '0',
			  irak mediumint(8) unsigned NOT NULL DEFAULT '0',
			  memi tinyint(3) unsigned NOT NULL DEFAULT '0',
			  krimi tinyint(3) unsigned NOT NULL DEFAULT '0',
			  deutsyn tinyint(3) unsigned NOT NULL DEFAULT '0',
			  solar tinyint(3) unsigned NOT NULL DEFAULT '0',
			  fusion tinyint(3) unsigned NOT NULL DEFAULT '0',
			  robo tinyint(3) unsigned NOT NULL DEFAULT '0',
			  nani tinyint(3) unsigned NOT NULL DEFAULT '0',
			  rawe tinyint(3) unsigned NOT NULL DEFAULT '0',
			  mesp tinyint(3) unsigned NOT NULL DEFAULT '0',
			  krissp tinyint(3) unsigned NOT NULL DEFAULT '0',
			  deutsp tinyint(3) unsigned NOT NULL DEFAULT '0',
			  folab tinyint(3) unsigned NOT NULL DEFAULT '0',
			  terra tinyint(3) unsigned NOT NULL DEFAULT '0',
			  allydep tinyint(3) unsigned NOT NULL DEFAULT '0',
			  raksilo tinyint(3) unsigned NOT NULL DEFAULT '0',
			  mbase tinyint(3) unsigned NOT NULL DEFAULT '0',
			  sensor tinyint(3) unsigned NOT NULL DEFAULT '0',
			  sprungtor tinyint(3) unsigned NOT NULL DEFAULT '0',
			  spiolvl tinyint(3) unsigned NOT NULL DEFAULT '0',
			  computech tinyint(3) unsigned NOT NULL DEFAULT '0',
			  waffentech tinyint(3) unsigned NOT NULL DEFAULT '0',
			  schildtech tinyint(3) unsigned NOT NULL DEFAULT '0',
			  rpz tinyint(3) unsigned NOT NULL DEFAULT '0',
			  energytech tinyint(3) unsigned NOT NULL DEFAULT '0',
			  hypertech tinyint(3) unsigned NOT NULL DEFAULT '0',
			  vbt tinyint(3) unsigned NOT NULL DEFAULT '0',
			  impulse tinyint(3) unsigned NOT NULL DEFAULT '0',
			  hra tinyint(3) unsigned NOT NULL DEFAULT '0',
			  lasertech tinyint(3) unsigned NOT NULL DEFAULT '0',
			  iontech tinyint(3) unsigned NOT NULL DEFAULT '0',
			  plasmatech tinyint(3) unsigned NOT NULL DEFAULT '0',
			  forschungsnetz tinyint(3) unsigned NOT NULL DEFAULT '0',
			  expedition tinyint(3) unsigned NOT NULL DEFAULT '0',
			  gravi tinyint(3) unsigned NOT NULL DEFAULT '0',
			  scantime datetime DEFAULT NULL,
			  scanned enum('ressources','fleet','defence','buildings','research') NOT NULL default 'ressources',
			  PRIMARY KEY (id),
			  UNIQUE KEY msg_id (msg_id),
			  KEY coordinates (galaxy,system,planet,moon)
			) DEFAULT CHARSET=utf8";
		if (!mysql_query($query)) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: reportarchive</td><td class=\"failure\">failure</td></tr>\n";
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
			$error_occured = true;
		} else {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: reportarchive</td><td class=\"success\">success</td></tr>\n";
		}

	// Player history - insert
	$query ="CREATE TRIGGER ".$dbprefix."players_ai AFTER INSERT ON $playertable
  FOR EACH ROW BEGIN
    INSERT INTO $playerhistory SET
    	year = DATE_FORMAT(NOW(),'%Y'),
    	month = DATE_FORMAT(NOW(),'%m'),
    	day = DATE_FORMAT(NOW(),'%e'),
    	player_id = NEW.id,
    	alliance_id = NEW.alliance_id,
    	rank = NEW.rank,
    	points = NEW.points,
    	frank = NEW.frank,
    	fpoints = NEW.fpoints,
    	rrank = NEW.rrank,
    	rpoints = NEW.rpoints,
    	erank = NEW.erank,
    	epoints = NEW.epoints;
    END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $playertable (Trigger 1)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $playertable (Trigger 1)</td><td class=\"success\">success</td></tr>\n";
	}

	$query ="CREATE TRIGGER ".$dbprefix."players_au AFTER UPDATE ON $playertable
  FOR EACH ROW BEGIN
    INSERT INTO $playerhistory SET
    	year = DATE_FORMAT(NOW(),'%Y'),
    	month = DATE_FORMAT(NOW(),'%m'),
    	day = DATE_FORMAT(NOW(),'%e'),
    	player_id = NEW.id,
    	alliance_id = NEW.alliance_id,
    	rank = NEW.rank,
    	points = NEW.points,
    	frank = NEW.frank,
    	fpoints = NEW.fpoints,
    	rrank = NEW.rrank,
    	rpoints = NEW.rpoints,
    	erank = NEW.erank,
    	epoints = NEW.epoints
    ON DUPLICATE KEY UPDATE
		rank=valueS(rank), points=VALUES(points),
		frank=valueS(frank), fpoints=VALUES(fpoints),
		rrank=valueS(rrank), rpoints=VALUES(rpoints),
		erank=valueS(erank), epoints=VALUES(epoints);
  END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $playertable (Trigger 2)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $playertable (Trigger 2)</td><td class=\"success\">success</td></tr>\n";
	}
	// Ally history - insert
	$query ="CREATE TRIGGER ".$dbprefix."alliances_ai AFTER INSERT ON $allytable
  FOR EACH ROW BEGIN
    INSERT INTO $allyhistory SET
    	year = DATE_FORMAT(NOW(),'%Y'),
    	month = DATE_FORMAT(NOW(),'%m'),
    	day = DATE_FORMAT(NOW(),'%e'),
    	alliance_id = NEW.id,
    	members = NEW.members,
    	rank = NEW.rank,
    	points = NEW.points,
    	frank = NEW.frank,
    	fpoints = NEW.fpoints,
    	rrank = NEW.rrank,
    	rpoints = NEW.rpoints,
    	erank = NEW.erank,
    	epoints = NEW.epoints;
    END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $allytable (Trigger 1)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $allytable (Trigger 1)</td><td class=\"success\">success</td></tr>\n";
	}
	// Ally history - update
	$query ="CREATE TRIGGER ".$dbprefix."alliances_au AFTER UPDATE ON $allytable
  FOR EACH ROW BEGIN
    INSERT INTO $allyhistory SET
    	year = DATE_FORMAT(NOW(),'%Y'),
    	month = DATE_FORMAT(NOW(),'%m'),
    	day = DATE_FORMAT(NOW(),'%e'),
    	alliance_id = NEW.id,
    	members = NEW.members,
    	rank = NEW.rank,
    	points = NEW.points,
    	frank = NEW.frank,
    	fpoints = NEW.fpoints,
    	rrank = NEW.rrank,
    	rpoints = NEW.rpoints,
    	erank = NEW.erank,
    	epoints = NEW.epoints
    ON DUPLICATE KEY UPDATE
		rank=values(rank), points=values(points),
		frank=values(frank), fpoints=values(fpoints),
		rrank=values(rrank), rpoints=values(rpoints),
		erank=values(erank), epoints=values(epoints);
  END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $allytable (Trigger 2)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $allytable (Trigger 2)</td><td class=\"success\">success</td></tr>\n";
	}

	$query ="CREATE TRIGGER ".$dbprefix."reports_ai AFTER INSERT ON $reporttable
	  FOR EACH ROW BEGIN
	   IF NEW.scanned = 'research' OR NEW.computech > 0 OR NEW.energytech > 0 THEN
	    UPDATE $playertable SET
	     spiolvl = NEW.spiolvl,
	     computech = NEW.computech,
	     waffentech = NEW.waffentech,
	     schildtech = NEW.schildtech,
	     rpz = NEW.rpz,
	     energytech = NEW.energytech,
	     hypertech = NEW.hypertech,
	     vbt=NEW.vbt,
	     impulse = NEW.impulse,
	     hra=NEW.hra,
	     lasertech = NEW.lasertech,
	     iontech = NEW.iontech,
	     plasmatech = NEW.plasmatech,
	     forschungsnetz = NEW.forschungsnetz,
	     expedition = NEW.expedition,
	     gravi = NEW.gravi,
	     last_tech_update = NOW()
	     WHERE id = (SELECT g.player_id FROM $reporttable r, $dbtablename g WHERE r.galaxy = g.galaxy AND r.system = g.system AND r.planet = g.planet AND r.planetname = g.planetname AND r.galaxy=NEW.galaxy AND r.system=NEW.system and r.planet=NEW.planet AND r.planetname=NEW.planetname LIMIT 1);
	  END IF;

	  IF NEW.msg_id > 0 THEN
	    INSERT IGNORE INTO $reportarchive SET
	    galaxy = NEW.galaxy,
	    system = NEW.system,
	    planet = NEW.planet,
	    moon = NEW.moon,
	    msg_id = NEW.msg_id,
	    metal = NEW.metal,
	    crystal = NEW.crystal,
	    deuterium = NEW.deuterium,
	    energy = NEW.energy,
	    scantime = NEW.scantime,
	    scanned = NEW.scanned,

	    kt = NEW.kt,
	    gt = NEW.gt,
	    lj = NEW.lj,
	    sj = NEW.sj,
	    krz = NEW.krz,
	    ss = NEW.ss,
	    kolo = NEW.kolo,
	    rec = NEW.rec,
	    spio = NEW.spio,
	    bomb = NEW.bomb,
	    zerri = NEW.zerri,
	    ds = NEW.ds,
	    skrz = NEW.skrz,
	    sat = NEW.sat,

	    rak = NEW.rak,
	    ll = NEW.ll,
	    sl = NEW.sl,
	    ion = NEW.ion,
	    gauss = NEW.gauss,
	    plasma = NEW.plasma,
	    ksk = NEW.ksk,
	    gsk = NEW.gsk,
	    arak = NEW.arak,
	    irak = NEW.irak,

	    memi = NEW.memi,
	    krimi = NEW.krimi,
	    deutsyn = NEW.deutsyn,
	    solar = NEW.solar,
	    fusion = NEW.fusion,
	    robo = NEW.robo,
	    nani = NEW.nani,
	    rawe = NEW.rawe,
	    mesp = NEW.mesp,
	    krissp = NEW.krissp,
	    deutsp = NEW.deutsp,
	    folab = NEW.folab,
	    terra = NEW.terra,
	    allydep = NEW.allydep,
	    raksilo = NEW.raksilo,
	    mbase = NEW.mbase,
	    sensor = NEW.sensor,
	    sprungtor = NEW.sprungtor,

	    spiolvl = NEW.spiolvl,
	    computech = NEW.computech,
	    waffentech = NEW.waffentech,
	    schildtech = NEW.schildtech,
	    rpz = NEW.rpz,
	    energytech = NEW.energytech,
	    hypertech = NEW.hypertech,
	    vbt = NEW.vbt,
	    impulse = NEW.impulse,
	    hra = NEW.hra,
	    lasertech = NEW.lasertech,
	    iontech = NEW.iontech,
	    plasmatech = NEW.plasmatech,
	    forschungsnetz = NEW.forschungsnetz,
	    expedition = NEW.expedition,
	    gravi = NEW.gravi;

	  END IF;
	END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $reporttable (Trigger 1)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $reporttable (Trigger 1)</td><td class=\"success\">success</td></tr>\n";
	}

	$query ="CREATE TRIGGER ".$dbprefix."reports_au AFTER UPDATE ON $reporttable
 FOR EACH ROW BEGIN
 	IF NEW.scanned = 'research' OR NEW.computech > 0 OR NEW.energytech > 0 THEN
	    UPDATE $playertable SET
	     spiolvl = NEW.spiolvl,
	     computech = NEW.computech,
	     waffentech = NEW.waffentech,
	     schildtech = NEW.schildtech,
	     rpz = NEW.rpz,
	     energytech = NEW.energytech,
	     hypertech = NEW.hypertech,
	     vbt=NEW.vbt,
	     impulse = NEW.impulse,
	     hra=NEW.hra,
	     lasertech = NEW.lasertech,
	     iontech = NEW.iontech,
	     plasmatech = NEW.plasmatech,
	     forschungsnetz = NEW.forschungsnetz,
	     expedition = NEW.expedition,
	     gravi = NEW.gravi,
	     last_tech_update = NOW()
	     WHERE id = (SELECT g.player_id FROM $reporttable r, $dbtablename g WHERE r.galaxy = g.galaxy AND r.system = g.system AND r.planet = g.planet AND r.planetname = g.planetname AND r.galaxy=NEW.galaxy AND r.system=NEW.system and r.planet=NEW.planet AND r.planetname=NEW.planetname  LIMIT 1);
	END IF;

	IF NEW.msg_id > 0 THEN
	INSERT IGNORE INTO $reportarchive SET
	galaxy = NEW.galaxy,
	system = NEW.system,
	planet = NEW.planet,
	moon = NEW.moon,
	msg_id = NEW.msg_id,
	metal = NEW.metal,
	crystal = NEW.crystal,
	deuterium = NEW.deuterium,
	energy = NEW.energy,
	scantime = NEW.scantime,
	scanned = NEW.scanned,

	kt = NEW.kt,
	gt = NEW.gt,
	lj = NEW.lj,
	sj = NEW.sj,
	krz = NEW.krz,
	ss = NEW.ss,
	kolo = NEW.kolo,
	rec = NEW.rec,
	spio = NEW.spio,
	bomb = NEW.bomb,
	zerri = NEW.zerri,
	ds = NEW.ds,
	skrz = NEW.skrz,
	sat = NEW.sat,

	rak = NEW.rak,
	ll = NEW.ll,
	sl = NEW.sl,
	ion = NEW.ion,
	gauss = NEW.gauss,
	plasma = NEW.plasma,
	ksk = NEW.ksk,
	gsk = NEW.gsk,
	arak = NEW.arak,
	irak = NEW.irak,

	memi = NEW.memi,
	krimi = NEW.krimi,
	deutsyn = NEW.deutsyn,
	solar = NEW.solar,
	fusion = NEW.fusion,
	robo = NEW.robo,
	nani = NEW.nani,
	rawe = NEW.rawe,
	mesp = NEW.mesp,
	krissp = NEW.krissp,
	deutsp = NEW.deutsp,
	folab = NEW.folab,
	terra = NEW.terra,
	allydep = NEW.allydep,
	raksilo = NEW.raksilo,
	mbase = NEW.mbase,
	sensor = NEW.sensor,
	sprungtor = NEW.sprungtor,

	spiolvl = NEW.spiolvl,
	computech = NEW.computech,
	waffentech = NEW.waffentech,
	schildtech = NEW.schildtech,
	rpz = NEW.rpz,
	energytech = NEW.energytech,
	hypertech = NEW.hypertech,
	vbt = NEW.vbt,
	impulse = NEW.impulse,
	hra = NEW.hra,
	lasertech = NEW.lasertech,
	iontech = NEW.iontech,
	plasmatech = NEW.plasmatech,
	forschungsnetz = NEW.forschungsnetz,
	expedition = NEW.expedition,
	gravi = NEW.gravi;

	END IF;
  END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $reporttable (Trigger 2)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $reporttable (Trigger 2)</td><td class=\"success\">success</td></tr>\n";
	}


	if (!$error_occured) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"success\" colspan=\"2\">Installation complete</td></tr>\n";
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">Installation failed</td></tr>\n";
	}
}
?>
</table>
</form>
</body>
</html>