<?php
session_start();

chdir("../");
$NO_PAGE_FORWARD = true;
include "logincheck.inc.php";
if (isset($error_page_code) && $error_page_code == "timeout") exit("");
if (!$_SESSION['s_cansearch']) {
	$error_page_code = "permission";
	include "errorpage.php";
	exit();
}
require "../config/config.php";
require "../config/attributes.php";
include_once "languages.php";

$type = "";
if (isset($_GET['type'])) {
	$type = $_GET['type'];
} elseif(isset($_POST['type'])) {
	$type = $_POST['type'];
}
if ($type == "") exit("type missing");

require "includes/stats.inc.php";
$stats_obj = new Stats($global_mysql_con, $utablename, $playertable, $allytable);
if (!($stats_obj instanceof Stats)) exit("Class init failed ");



switch ($type) {
	case "playerstatsUI":
		$content = $stats_obj->getPlayerStatsUI(false,$OGame_3_0);
		exit($content);
		break;

	case "allystatsUI":
		$content = $stats_obj->getAllyStatsUI(false,$OGame_3_0);
		exit($content);
		break;

	case "playerstatsUI_military":
		$content = $stats_obj->getPlayerStatsUI(true,$OGame_3_0);
		exit($content);
		break;

	case "allystatsUI_military":
		$content = $stats_obj->getAllyStatsUI(true,$OGame_3_0);
		exit($content);
		break;

	case "playerstats":
		$start    = (isset($_GET['start'])) ? intval($_GET['start']) : 0;
		$count    = (isset($_GET['count'])) ? intval($_GET['count']) : 50;
		$sort     = (isset($_GET['sort'])) ? $_GET['sort'] : "rank";
		$military = (isset($_GET['military']) && $_GET['military'] == "true") ? true : false;
		if ($military === true && $sort == "rank") $sort = "-fb";

		$inactive = (isset($_GET['inactive'])) ? $_GET['inactive'] : null;
		$vacation = (isset($_GET['vacation'])) ? $_GET['vacation'] : null;
		$noob     = (isset($_GET['noob'])) ? $_GET['noob'] : null;

		if (substr($sort,0,1) == "-") {
			$sortorder = Stats::descending;
			$sort = substr($sort, 1);
		} else {
			$sortorder = Stats::ascending;
		}

		$content = $stats_obj->getPlayerStats($start, $count, $sort, $sortorder, $inactive, $vacation, $noob);
		exit($content);
		break;

	case "allystats":
		$start   = (isset($_GET['start'])) ? intval($_GET['start']) : 0;
		$count   = (isset($_GET['count'])) ? intval($_GET['count']) : 50;
		$sort    = (isset($_GET['sort'])) ? $_GET['sort'] : "rank";
		$military = (isset($_GET['military']) && $_GET['military'] == "true") ? true : false;
		if ($military === true && $sort == "rank") $sort = "-fb";

		if (substr($sort,0,1) == "-") {
			$sortorder = Stats::descending;
			$sort = substr($sort, 1);
		} else {
			$sortorder = Stats::ascending;
		}

		$content = $stats_obj->getAllyStats($start, $count, $sort, $sortorder);
		exit($content);
		break;

	case "graph":
		$id = (isset($_GET['id'])) ? intval($_GET['id']) : 0;
		$content = $stats_obj->getAllyGraph($id, $OGame_3_0);
		exit($content);

		break;

	case "player_delete":
		if ($_SESSION['s_candelete'] !== true) exit("no permissions");
		$player_id = intval($_GET['player_id']);
		$content = Stats::player_delete($player_id, $global_mysql_con, $playertable, $playerhistory, $noticetable, $dbtablename, $combatparty, $combattable, $player_activity, $messagetable);
		exit($content);
		break;

	case "alliance_delete":
		if ($_SESSION['s_candelete'] !== true) exit("no permissions");
		$alliance_id = intval($_GET['alliance_id']);
		$content = $stats_obj->alliance_delete($alliance_id);
		exit($content);
		break;

	case "change_player":
		if ($_SESSION['s_diplomatic'] !== true) exit("no permissions");
		$player_id = intval($_GET['player_id']);
		$content = $stats_obj->change_player($player_id, $_GET['new_status']);
		exit($content);
		break;

	case "change_alliance":
		if ($_SESSION['s_diplomatic'] !== true) exit("no permissions");
		$alliance_id = intval($_GET['alliance_id']);
		$content = $stats_obj->change_alliance($alliance_id, $_GET['new_status']);
		exit ($content);
		break;

	default: exit("");

}