<?php
/*
* Displayfunctions for Galaxytool
*/


class DisplayFunctions {


	function dialog_window($title,$content,$dialog_id="dialog_window",$closebutton=true,$width=250,$min_height=100) {
		echo '
			<div class="firstcolor" style="width:'.$width.'; min-height:'.$min_height.';">
			<div class="tblhead" style="height:16px;">
			<div style="position:absolute; left:10px; top: 2px;">'.$title.'</div>';
		if ($closebutton) echo '
		<div style="position:absolute; right:5px;">
		<img src="../images/close.png" onclick="hideUnhideObject(\''.$dialog_id.'\')" alt="close" /></div>';
		echo '&nbsp;</div>
			<div class="firstcolor">'."\n";
		echo $content;
		echo '</div>'; // content div
		echo '</div>'; // dialog div

	}


	function table_row($data,$highlightrow=false) {
		if ($highlightrow) {
			echo '<tr class="firstcolor" onmouseover="this.setAttribute(\'class\',\'row_focus\')" onmouseout="this.setAttribute(\'class\',\'firstcolor\')" >'."\n";
		} else {
			echo '<tr class="firstcolor">'."\n";
		}
		

		$last_td_no = 1;
		foreach ($data as $td => $td_details) {
			echo "<td";
			if ($td - $last_td_no > 0) {
				if (isset($td_details['td_attr']) && strpos($td_details['td_attr'],"colspan") === false) {
				echo " colspan=".($td - $last_td_no);
				}
			}
			if (isset($td_details["td_attr"])) {
				echo " ".$td_details["td_attr"];
			}

			echo ">".$td_details["content"]."</td>";

			$last_td_no = $td;
		}
		echo "</tr>\n";
	}
	
	function input_field($name,$initval="",$style="",$type="text",$highlight=true,$size="",$maxlength="",$tabindex="",$id="",$other="") {
		$html_code = '<input class="textfield" ';
		if (!empty($id)) {
			$html_code .= ' id="'.$id.'"';
		}
		
		if (!empty($style)) {
			$html_code .= ' style="'.$style.'"';
		}
		if ($highlight) {
			$html_code .= ' onfocus="this.className=\'textfield_focus\'" onblur="this.className=\'textfield\'"';
		}
		$html_code .= ' name="'.$name.'" type="'.$type.'" value="'.$initval.'" ';
		if (!empty($size)) $html_code .= ' size="'.$size.'"';
		if (!empty($maxlength)) $html_code .= ' maxlength="'.$maxlength.'"';
		if (!empty($tabindex)) $html_code .= ' tabindex="'.$tabindex.'"';
		
		if (!empty($other)) {
			$html_code .= ' '.$other;
		}
		
		$html_code .= " />";
		return $html_code;
	}
	
	
	public static function get_coordinates_control() {
		$html_code = '<input type="text" name="coordinates" value="" dojoType="dijit.form.ValidationTextBox" trim="true" 
		               id="coordinates" propercase="false" style="width:130px;">
 			<div dojoType="dijit.form.DropDownButton" iconClass="application_windows_icon" label="">
            <div dojoType="dijit.TooltipDialog">
            	<table border="0" cellpadding="0" cellspacing="2">
            	<tr>
            	<td>'.COMBATS_GALAXY_FROM_TO.'</td>
            	<td>
            	<input type="text" name="galaxy1" id="galaxy1" value="" dojoType="dijit.form.ValidationTextBox"
        		regExp="[\d]+" required="true" invalidMessage="'.COMBATS_INVALID_GALAXY_ENTERED.'"
        		style="width:30px;"></td>
            	<td>-</td>
            	<td>
            	<input type="text" name="galaxy2" id="galaxy2" value="" dojoType="dijit.form.ValidationTextBox"
        		regExp="[\d]*" invalidMessage="'.COMBATS_INVALID_GALAXY_ENTERED.'"
        		style="width:30px;">
            	</td>
            	</tr>
            	<tr>
            	<td>'.COMBATS_SYSTEM_FROM_TO.'</td>
            	<td>
            	<input type="text" name="system1" id="system1" value="" dojoType="dijit.form.ValidationTextBox"
        		regExp="[\d]*" invalidMessage="'.COMBATS_INVALID_SYSTEM_ENTERED.'"
        		style="width:30px;"></td>
            	<td>-</td>
            	<td>
            	<input type="text" name="system2" id="system2" value="" dojoType="dijit.form.ValidationTextBox"
        		regExp="[\d]*" invalidMessage="'.COMBATS_INVALID_SYSTEM_ENTERED.'"
        		style="width:30px;">
            	</td>
            	</tr>
            	<tr>
            	<td>'.COMBATS_PLANET_FROM_TO.'</td>
            	<td>
            	<input type="text" name="planet1" id="planet1" value="" dojoType="dijit.form.ValidationTextBox"
        		regExp="[\d]*" invalidMessage="'.COMBATS_INVALID_PLANET_ENTERED.'"
        		style="width:30px;"></td>
            	<td>-</td>
            	<td>
            	<input type="text" name="planet2" id="planet2" value="" dojoType="dijit.form.ValidationTextBox"
        		regExp="[\d]*" invalidMessage="'.COMBATS_INVALID_PLANET_ENTERED.'"
        		style="width:30px;">
            	</td>
            	</tr>
            	<tr>
            	<td colspan="4">
                <button dojoType="dijit.form.Button" type="button" onClick="galaxytool_apply_coordinates(\'coordinates\')">'.COMBATS_APPLY.'</button>
            	</td>
            	</tr>
            	</table>
            </div>
        </div>		
		';
		return $html_code;
		
	}

}
?>