<?php
header ("Content-Type:text/xml");
//header("content-type: text/html; charset=utf-8"); // to see what happens even with PHP runtime errors

/*
* first page to be adressed when it comes to XML transfer via firefox extension
*
* Precondition:
* - Content is sent via POST method
*   $_POST['content'] contains the XML content
*   $_POST['type'] is the content type (equal to content_type in header.xsd)
*/

@require_once "error_object.inc.php";
@require "../config/config.php";
@require "../config/attributes.php";

// connect to DB
$dbcon = mysql_connect($dbhost,$dbusername,$dbpassword);
if (!$dbcon) {
	$msg_obj = new ErrorObject(ErrorObject::severity_error,"DB connect failed"); // no return code
	exit($msg_obj->get_xml_result($global_universe));
}
if (mysql_select_db($dbname,$dbcon) === false) {
	$msg_obj = new ErrorObject(ErrorObject::severity_error,"DB does not exist"); // no return code
	exit($msg_obj->get_xml_result($global_universe));
}

if (isset($_POST['type']) && $_POST['type'] == 'validate') {
	require "galaxyplugin_validate.inc.php";

	$user     = (isset($_POST['user']))     ? $_POST['user']     : "";
	$password = (isset($_POST['password'])) ? $_POST['password'] : "";
	$token    = (isset($_POST['token']))    ? $_POST['token']    : "";

	if ($user == "" && $password == "" && $token == "") {
		$msg_obj = new ErrorObject(ErrorObject::severity_info,""); // no message added will just return the xml header with universe and version
		exit($msg_obj->get_xml_result($global_universe));
	}
	$validate = new GalaxypluginValidation($dbcon,$utablename,$user,$password, $token, $global_universe);
	if ($validate === false) {
		exit($validate->error_object->get_xml_result($global_universe));
	}
	$result = $validate->get_insert_permissions();
	if ($result === false) {
		exit($validate->error_object->get_xml_result($global_universe));
	}

	// no error occurred - return XML
	exit($result);

}

if (!isset($_POST['content']) || !isset($_POST['type'])) {
	exit("<?xml version=\"1.0\" encoding=\"UTF-8\"?><invalid_call/>");
}
$_POST['content'] = stripslashes($_POST['content']);


switch ($_POST['type']) {
	case 'galaxyview':
		@require "parser.inc.php";
		$parser = new Parser($dbcon,$dbtablename,$allytable,$playertable,$utablename,$player_activity,$global_universe);
		break;

	case 'player_stats':
	case 'player_highscore':
		@require "parser_stats.inc.php";
		$parser = new StatsParser($dbcon,$allytable,$playertable,$utablename,$global_universe);
		break;

	case 'ally_stats':
	case 'ally_highscore':
		@require "parser_stats.inc.php";
		$parser = new StatsParser($dbcon,$allytable,$playertable,$utablename,$global_universe);
		break;

	case 'allypage':
		@require "parser_allypage.inc.php";
		$parser = new AllypageParser($dbcon,$allytable,$playertable,$utablename,$player_activity,$global_universe);
		break;

	case 'reports':
		@require "parser_reports.inc.php";
		$parser = new ReportParser($dbcon,$reporttable,$dbtablename,$playertable,$utablename,$global_universe);
		break;

	case 'planetinfo':
		@require "parser_planetinfo.inc.php";
		$parser = new PlanetinfoParser($dbcon,$reporttable,$dbtablename,$playertable,$utablename,$global_universe);
		break;

	case 'fleet_movement':
		require "parser_fleet_movement.inc.php";
		$parser = new FleetMovementParser($dbcon,$fleetmovetable,$utablename,$global_universe);
		break;

	case 'espionage':
		require "parser_espionage.inc.php";
		$parser = new EspionageParser($dbcon,$dbtablename,$utablename,$player_activity,$global_universe);
		break;

	case 'message':
		require "parser_messages.inc.php";
		$parser = new MessageParser($dbcon,$messagetable,$utablename,$playertable,$player_activity,$global_universe);
		break;

	case 'combat_report':
		require "parser_combat_reports.inc.php";
		$parser = new CombatParser($dbcon,$combattable,$combatparty,$utablename,$dbtablename,$player_activity,$global_universe);
		break;

	default:
		$msg_obj = new ErrorObject(ErrorObject::severity_error,"invlid type: ".$_POST['type']); // no return code
		exit($msg_obj->get_xml_result($global_universe));
		break;
}

// pass XML content to parser
$result = $parser->insert_data($_POST['content']);

// check result and return to extension
if ($result === true) {
	// everything worked fine
	// check if we collected some messages on the way
	$messages = $parser->get_error_object();
	if ($messages != null) {
		exit($messages->get_xml_result($global_universe));
	} else {
		$msg_obj = new ErrorObject(ErrorObject::severity_error,"Fatal error: we got no return code but result: true"); // no return code
		exit($msg_obj->get_xml_result($global_universe));
	}
} else {
	// we have an unexpected error situation with "return false"
	// check if we collected some messages on the way
	$messages = $parser->get_error_object();
	if ($messages != null) {
		exit($messages->get_xml_result($global_universe));
	} else {
		$msg_obj = new ErrorObject(ErrorObject::severity_error,"Unexpected error occurred with no detailed messages"); // no return code
		exit($msg_obj->get_xml_result($global_universe));
	}
}

?>