/**
 * Javascript file for sources needed at allyinformation.php
 */

dojo.require("dojo.data.ItemFileReadStore");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dojox.grid.DataGrid");
var store1 = null;

function galaxytool_centered_formatter(val, rowIdx, cell) {
	cell.customClasses.push("centered_text");
	return val;
}

function galaxytool_score_formatter(val, rowIdx, cell) {
	cell.customClasses.push("centered_text");
	return NumberFormat(val);
}

function galaxytool_player_formatter(val, rowIdx, cell) {
	cell.customClasses.push("centered_text");
	cell.customClasses.push("hyperlink");
	
	var dipl_status = store1.getValues(grid1.getItem(rowIdx),"dipl_status");
	
	if (dipl_status != "nothing") {
		val = "<span class=\""+dipl_status+"\">"+val+"</span>";
	}	
	return val;
}

function galaxytool_member_cellclick(e) {
	if (e.cellIndex != 0) return;

	var id = e.grid.store.getValue(e.grid.getItem(e.rowIndex),"player_id");
	var url = "playerinformation.php?id="+id;
	window.location.href = url;
}

function galaxytool_allyinformation_init() {
	// select user defined tab
	var choosen_tab = window.location.hash;
	if (choosen_tab != "") {
		try {
			choosen_tab = choosen_tab.replace(/#select_/, "");
			dijit.byId("tabcontainer").selectChild(dijit.byId(choosen_tab));
		} catch (ignore) {
			// select default tab in case of wrong user input
		}
	}

	dojo.subscribe("tabcontainer-selectChild", function(child) {
		window.location.hash = "#select_" + child.get("id");
	});
	
	// define store with data
    store1 = new dojo.data.ItemFileReadStore({data: storeData});
    store1.comparatorMap={};
    store1.comparatorMap["playername"] = function (a, b) { return a.localeCompare(b); };
    grid1.setStore(store1);
    
    dojo.connect(grid1, "onCellClick", galaxytool_member_cellclick);
}

dojo.addOnLoad(galaxytool_allyinformation_init);
