/**
 * Javascript file for sources needed at userinfo.php
 */

dojo.require("dojo.data.ItemFileReadStore");
dojo.require("dijit.layout.TabContainer");
dojo.require("dojox.layout.ContentPane");
dojo.require("dojox.grid.DataGrid");
dojo.require("dijit.form.Select");

function galaxytool_status_formatter(val, rowIdx, cell) {
	var style = store1.getValues(grid1.getItem(rowIdx),"status_style");
	var url = store1.getValues(grid1.getItem(rowIdx),"url");
	cell.customClasses.push(style);
	cell.customClasses.push("centered_text");
	
	if (url != "") {
		val = "<a class=\""+style+"\" href=\""+url+"\">"+val+"</a>";
		return val;
	} 
	return val;
}
function galaxytool_centered_formatter(val, rowIdx, cell) {
	cell.customClasses.push("centered_text");
	return val;
}
function galaxytool_compare_integer (a,b) {
   if (parseInt(a) < parseInt(b)){
     return -1;
   } else if (parseInt(a) > parseInt(b)) {
     return 1;
   } else {
     return 0;
   }
}

function galaxytool_compare_float (a,b) {
   if (parseFloat(a) < parseFloat(b)){
     return -1;
   } else if (parseFloat(a) > parseFloat(b)) {
     return 1;
   } else {
     return 0;
   }
}

function galaxytool_load_new_User(newValue) {
	var store_url = "ajax/ajax_userinfo.php?type=ipdetails&userid="+newValue;
	
	// reload content from URL
	store4.url = store_url;
	store4.close();
	grid4.setStore(store4);
}

function galaxytool_new_tab_loaded(data) {
	dojo.connect(dijit.byId("user_select"), "onChange", galaxytool_load_new_User );
}

function galaxytool_userinfo_init() {
	// select user defined tab
	var choosen_tab = window.location.hash;
	if (choosen_tab != "") {
		try {
			choosen_tab = choosen_tab.replace(/#select_/, "");
			dijit.byId("tabcontainer").selectChild(dijit.byId(choosen_tab));
		} catch (ignore) {
			// select default tab in case of wrong user input
		}
	}

	dojo.subscribe("tabcontainer-selectChild", function(child) {
		window.location.hash = "#select_" + child.get("id");
	});
	
	// dojo.connect(dijit.byId("user_select"), "onChange", galaxytool_load_new_IP ); <-- connection is created on TAB load
	dojo.connect(dijit.byId("tab4"), "onLoad", galaxytool_new_tab_loaded );
}

dojo.addOnLoad(galaxytool_userinfo_init);